Index: library/bdm/base/bdmbase.h
===================================================================
--- library/bdm/base/bdmbase.h (revision 487)
+++ library/bdm/base/bdmbase.h (revision 488)
@@ -660,42 +670,43 @@
 This class abstracts logging of results from implementation. This class replaces direct logging of results (e.g. to files or to global variables) by calling methods of a logger. Specializations of this abstract class for specific storage method are designed.
  */
-class logger : public root {
-protected:
-	//! RVs of all logged variables.
-	Array<RV> entries;
-	//! Names of logged quantities, e.g. names of algorithm variants
-	Array<string> names;
-public:
-	//!Default constructor
-	logger() : entries ( 0 ), names ( 0 ) {}
-
-	//! returns an identifier which will be later needed for calling the \c logit() function
-	//! For empty RV it returns -1, this entry will be ignored by \c logit().
-	virtual int add ( const RV &rv, string prefix = "" ) {
-		int id;
-		if ( rv._dsize() > 0 ) {
-			id = entries.length();
-			names = concat ( names, prefix ); // diff
-			entries.set_length ( id + 1, true );
-			entries ( id ) = rv;
-		} else {
-			id = -1;
-		}
-		return id; // identifier of the last entry
-	}
-
-	//! log this vector
-	virtual void logit ( int id, const vec &v ) = 0;
-	//! log this double
-	virtual void logit ( int id, const double &d ) = 0;
-
-	//! Shifts storage position for another time step.
-	virtual void step() = 0;
-
-	//! Finalize storing information
-	virtual void finalize() {};
-
-	//! Initialize the storage
-	virtual void init() {};
+class logger : public root
+{
+	protected:
+		//! RVs of all logged variables.
+		Array<RV> entries;
+		//! Names of logged quantities, e.g. names of algorithm variants
+		Array<string> names;
+	public:
+		//!Default constructor
+		logger() : entries (0), names (0) {}
+
+		//! returns an identifier which will be later needed for calling the \c logit() function
+		//! For empty RV it returns -1, this entry will be ignored by \c logit().
+		virtual int add (const RV &rv, string prefix = "") {
+			int id;
+			if (rv._dsize() > 0) {
+				id = entries.length();
+				names = concat (names, prefix);   // diff
+				entries.set_length (id + 1, true);
+				entries (id) = rv;
+			} else {
+				id = -1;
+			}
+			return id; // identifier of the last entry
+		}
+
+		//! log this vector
+		virtual void logit (int id, const vec &v) = 0;
+		//! log this double
+		virtual void logit (int id, const double &d) = 0;
+
+		//! Shifts storage position for another time step.
+		virtual void step() = 0;
+
+		//! Finalize storing information
+		virtual void finalize() {};
+
+		//! Initialize the storage
+		virtual void init() {};
 
 };
@@ -704,57 +715,59 @@
 
 */
-class mepdf : public mpdf {
-
-shared_ptr<epdf> ipdf;
-public:
-	//!Default constructor
-	mepdf() { }
-
-	mepdf ( shared_ptr<epdf> em ) {
-		ipdf = em;
-		set_ep(*ipdf.get());
-		dimc = 0;
-	}
-
-	//! empty
-	void condition ( const vec &cond );
-
-	//! Load from structure with elements:
-	//!  \code
-	//! { class = "mepdf",
-	//!   epdf = {class="epdf_offspring",...}
-	//! }
-	//! \endcode
-	//!@}
-	void from_setting ( const Setting &set );
-};
-UIREGISTER ( mepdf );
+class mepdf : public mpdf
+{
+
+		shared_ptr<epdf> ipdf;
+	public:
+		//!Default constructor
+		mepdf() { }
+
+		mepdf (shared_ptr<epdf> em) {
+			ipdf = em;
+			set_ep (*ipdf.get());
+			dimc = 0;
+		}
+
+		//! empty
+		void condition (const vec &cond);
+
+		//! Load from structure with elements:
+		//!  \code
+		//! { class = "mepdf",
+		//!   epdf = {class="epdf_offspring",...}
+		//! }
+		//! \endcode
+		//!@}
+		void from_setting (const Setting &set);
+};
+UIREGISTER (mepdf);
 
 //!\brief Chain rule of pdfs - abstract part common for mprod and merger.
 //!this abstract class is common to epdf and mpdf
 //!\todo Think of better design - global functions rv=get_rv(Array<mpdf*> mpdfs); ??
-class compositepdf {
-protected:
-	//! Elements of composition
-	Array<mpdf*> mpdfs;
-	bool owning_mpdfs;
-public:
-	compositepdf() : mpdfs ( 0 ) {};
-	compositepdf ( Array<mpdf*> A0, bool own = false ) {
-		set_elements ( A0, own );
-	};
-	void set_elements ( Array<mpdf*> A0, bool own = false ) {
-		mpdfs = A0;
-		owning_mpdfs = own;
-	};
-	//! find common rv, flag \param checkoverlap modifies whether overlaps are acceptable
-	RV getrv ( bool checkoverlap = false );
-	//! common rvc of all mpdfs is written to rvc
-	void setrvc ( const RV &rv, RV &rvc );
-	~compositepdf() {
-		if ( owning_mpdfs ) for ( int i = 0; i < mpdfs.length(); i++ ) {
-				delete mpdfs ( i );
-			}
-	};
+class compositepdf
+{
+	protected:
+		//! Elements of composition
+		Array<mpdf*> mpdfs;
+		bool owning_mpdfs;
+	public:
+		compositepdf() : mpdfs (0) {};
+		compositepdf (Array<mpdf*> A0, bool own = false) {
+			set_elements (A0, own);
+		};
+		void set_elements (Array<mpdf*> A0, bool own = false) {
+			mpdfs = A0;
+			owning_mpdfs = own;
+		};
+		//! find common rv, flag \param checkoverlap modifies whether overlaps are acceptable
+		RV getrv (bool checkoverlap = false);
+		//! common rvc of all mpdfs is written to rvc
+		void setrvc (const RV &rv, RV &rvc);
+		~compositepdf() {
+			if (owning_mpdfs) for (int i = 0; i < mpdfs.length(); i++) {
+					delete mpdfs (i);
+				}
+		};
 };
 
@@ -766,67 +779,68 @@
 */
 
-class DS : public root {
-protected:
-	int dtsize;
-	int utsize;
-	//!Description of data returned by \c getdata().
-	RV Drv;
-	//!Description of data witten by by \c write().
-	RV Urv; //
-	//! Remember its own index in Logger L
-	int L_dt, L_ut;
-public:
-	//! default constructors
-	DS() : Drv(), Urv() {};
-	//! Returns full vector of observed data=[output, input]
-	virtual void getdata ( vec &dt ) {
-		it_error ( "abstract class" );
-	};
-	//! Returns data records at indeces.
-	virtual void getdata ( vec &dt, const ivec &indeces ) {
-		it_error ( "abstract class" );
-	};
-	//! Accepts action variable and schedule it for application.
-	virtual void write ( vec &ut ) {
-		it_error ( "abstract class" );
-	};
-	//! Accepts action variables at specific indeces
-	virtual void write ( vec &ut, const ivec &indeces ) {
-		it_error ( "abstract class" );
-	};
-
-	//! Moves from \f$ t \f$ to \f$ t+1 \f$, i.e. perfroms the actions and reads response of the system.
-	virtual void step() = 0;
-
-	//! Register DS for logging into logger L
-	virtual void log_add ( logger &L ) {
-		it_assert_debug ( dtsize == Drv._dsize(), "" );
-		it_assert_debug ( utsize == Urv._dsize(), "" );
-
-		L_dt = L.add ( Drv, "" );
-		L_ut = L.add ( Urv, "" );
-	}
-	//! Register DS for logging into logger L
-	virtual void logit ( logger &L ) {
-		vec tmp ( Drv._dsize() + Urv._dsize() );
-		getdata ( tmp );
-		// d is first in getdata
-		L.logit ( L_dt, tmp.left ( Drv._dsize() ) );
-		// u follows after d in getdata
-		L.logit ( L_ut, tmp.mid ( Drv._dsize(), Urv._dsize() ) );
-	}
-	//!access function
-	virtual RV _drv() const {
-		return concat ( Drv, Urv );
-	}
-	//!access function
-	const RV& _urv() const {
-		return Urv;
-	}
-	//! set random rvariables
-	virtual void set_drv ( const  RV &drv, const RV &urv ) {
-		Drv = drv;
-		Urv = urv;
-	}
+class DS : public root
+{
+	protected:
+		int dtsize;
+		int utsize;
+		//!Description of data returned by \c getdata().
+		RV Drv;
+		//!Description of data witten by by \c write().
+		RV Urv; //
+		//! Remember its own index in Logger L
+		int L_dt, L_ut;
+	public:
+		//! default constructors
+		DS() : Drv(), Urv() {};
+		//! Returns full vector of observed data=[output, input]
+		virtual void getdata (vec &dt) {
+			it_error ("abstract class");
+		};
+		//! Returns data records at indeces.
+		virtual void getdata (vec &dt, const ivec &indeces) {
+			it_error ("abstract class");
+		};
+		//! Accepts action variable and schedule it for application.
+		virtual void write (vec &ut) {
+			it_error ("abstract class");
+		};
+		//! Accepts action variables at specific indeces
+		virtual void write (vec &ut, const ivec &indeces) {
+			it_error ("abstract class");
+		};
+
+		//! Moves from \f$ t \f$ to \f$ t+1 \f$, i.e. perfroms the actions and reads response of the system.
+		virtual void step() = 0;
+
+		//! Register DS for logging into logger L
+		virtual void log_add (logger &L) {
+			it_assert_debug (dtsize == Drv._dsize(), "");
+			it_assert_debug (utsize == Urv._dsize(), "");
+
+			L_dt = L.add (Drv, "");
+			L_ut = L.add (Urv, "");
+		}
+		//! Register DS for logging into logger L
+		virtual void logit (logger &L) {
+			vec tmp (Drv._dsize() + Urv._dsize());
+			getdata (tmp);
+			// d is first in getdata
+			L.logit (L_dt, tmp.left (Drv._dsize()));
+			// u follows after d in getdata
+			L.logit (L_ut, tmp.mid (Drv._dsize(), Urv._dsize()));
+		}
+		//!access function
+		virtual RV _drv() const {
+			return concat (Drv, Urv);
+		}
+		//!access function
+		const RV& _urv() const {
+			return Urv;
+		}
+		//! set random rvariables
+		virtual void set_drv (const  RV &drv, const RV &urv) {
+			Drv = drv;
+			Urv = urv;
+		}
 };
 
@@ -852,155 +866,201 @@
 */
 
-class BM : public root {
-protected:
-	//! Random variable of the data (optional)
-	RV drv;
-	//!Logarithm of marginalized data likelihood.
-	double ll;
-	//!  If true, the filter will compute likelihood of the data record and store it in \c ll . Set to false if you want to save computational time.
-	bool evalll;
-public:
-	//! \name Constructors
-	//! @{
-
-	BM() : ll ( 0 ), evalll ( true ), LIDs ( 4 ), LFlags ( 4 ) {
-		LIDs = -1;/*empty IDs*/
-		LFlags = 0;
-		LFlags ( 0 ) = 1;/*log only mean*/
-	};
-	BM ( const BM &B ) :  drv ( B.drv ), ll ( B.ll ), evalll ( B.evalll ) {}
-	//! Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually!
-	//! Prototype: \code BM* _copy_() const {return new BM(*this);} \endcode
-	virtual BM* _copy_() const {
-		return NULL;
-	};
-	//!@}
-
-	//! \name Mathematical operations
-	//!@{
-
-	/*! \brief Incremental Bayes rule
-	@param dt vector of input data
-	*/
-	virtual void bayes ( const vec &dt ) = 0;
-	//! Batch Bayes rule (columns of Dt are observations)
-	virtual void bayesB ( const mat &Dt );
-	//! Evaluates predictive log-likelihood of the given data record
-	//! I.e. marginal likelihood of the data with the posterior integrated out.
-	virtual double logpred ( const vec &dt ) const {
-		it_error ( "Not implemented" );
-		return 0.0;
+class BM : public root
+{
+	protected:
+		//! Random variable of the data (optional)
+		RV drv;
+		//!Logarithm of marginalized data likelihood.
+		double ll;
+		//!  If true, the filter will compute likelihood of the data record and store it in \c ll . Set to false if you want to save computational time.
+		bool evalll;
+	public:
+		//! \name Constructors
+		//! @{
+
+		BM() : ll (0), evalll (true), LIDs (4), LFlags (4) {
+			LIDs = -1;/*empty IDs*/
+			LFlags = 0;
+			LFlags (0) = 1;  /*log only mean*/
+		};
+		BM (const BM &B) :  drv (B.drv), ll (B.ll), evalll (B.evalll) {}
+		//! Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually!
+		//! Prototype: \code BM* _copy_() const {return new BM(*this);} \endcode
+		virtual BM* _copy_() const {
+			return NULL;
+		};
+		//!@}
+
+		//! \name Mathematical operations
+		//!@{
+
+		/*! \brief Incremental Bayes rule
+		@param dt vector of input data
+		*/
+		virtual void bayes (const vec &dt) = 0;
+		//! Batch Bayes rule (columns of Dt are observations)
+		virtual void bayesB (const mat &Dt);
+		//! Evaluates predictive log-likelihood of the given data record
+		//! I.e. marginal likelihood of the data with the posterior integrated out.
+		virtual double logpred (const vec &dt) const {
+			it_error ("Not implemented");
+			return 0.0;
+		}
+		//! Matrix version of logpred
+		vec logpred_m (const mat &dt) const {
+			vec tmp (dt.cols());
+			for (int i = 0; i < dt.cols(); i++) {
+				tmp (i) = logpred (dt.get_col (i));
+			}
+			return tmp;
+		}
+
+		//!Constructs a predictive density \f$ f(d_{t+1} |d_{t}, \ldots d_{0}) \f$
+		virtual epdf* epredictor() const {
+			it_error ("Not implemented");
+			return NULL;
+		};
+		//!Constructs a conditional density 1-step ahead predictor \f$ f(d_{t+1} |d_{t+h-1}, \ldots d_{t})
+		virtual mpdf* predictor() const {
+			it_error ("Not implemented");
+			return NULL;
+		};
+		//!@}
+
+		//! \name Extension to conditional BM
+		//! This extension is useful e.g. in Marginalized Particle Filter (\ref bdm::MPF).
+		//! Alternatively, it can be used for automated connection to DS when the condition is observed
+		//!@{
+
+		//! Name of extension variable
+		RV rvc;
+		//! access function
+		const RV& _rvc() const {
+			return rvc;
+		}
+
+		//! Substitute \c val for \c rvc.
+		virtual void condition (const vec &val) {
+			it_error ("Not implemented!");
+		};
+
+		//!@}
+
+
+		//! \name Access to attributes
+		//!@{
+
+		const RV& _drv() const {
+			return drv;
+		}
+		void set_drv (const RV &rv) {
+			drv = rv;
+		}
+		void set_rv (const RV &rv) {
+			const_cast<epdf&> (posterior()).set_rv (rv);
+		}
+		double _ll() const {
+			return ll;
+		}
+		void set_evalll (bool evl0) {
+			evalll = evl0;
+		}
+		virtual const epdf& posterior() const = 0;
+		virtual const epdf* _e() const = 0;
+		//!@}
+
+		//! \name Logging of results
+		//!@{
+
+		//! Set boolean options from a string, recognized are: "logbounds,logll"
+		virtual void set_options (const string &opt) {
+			LFlags (0) = 1;
+			if (opt.find ("logbounds") != string::npos) {
+				LFlags (1) = 1;
+				LFlags (2) = 1;
+			}
+			if (opt.find ("logll") != string::npos) {
+				LFlags (3) = 1;
+			}
+		}
+		//! IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll]
+		ivec LIDs;
+
+		//! Flags for logging - same size as LIDs, each entry correspond to the same in LIDs
+		ivec LFlags;
+		//! Add all logged variables to a logger
+		virtual void log_add (logger &L, const string &name = "") {
+			// internal
+			RV r;
+			if (posterior().isnamed()) {
+				r = posterior()._rv();
+			} else {
+				r = RV ("est", posterior().dimension());
+			};
+
+			// Add mean value
+			if (LFlags (0)) LIDs (0) = L.add (r, name + "mean_");
+			if (LFlags (1)) LIDs (1) = L.add (r, name + "lb_");
+			if (LFlags (2)) LIDs (2) = L.add (r, name + "ub_");
+			if (LFlags (3)) LIDs (3) = L.add (RV ("ll", 1), name);              //TODO: "local" RV
+		}
+		virtual void logit (logger &L) {
+			L.logit (LIDs (0), posterior().mean());
+			if (LFlags (1) || LFlags (2)) {        //if one of them is off, its LID==-1 and will not be stored
+				vec ub, lb;
+				posterior().qbounds (lb, ub);
+				L.logit (LIDs (1), lb);
+				L.logit (LIDs (2), ub);
+			}
+			if (LFlags (3)) L.logit (LIDs (3), ll);
+		}
+		//!@}
+};
+
+template<class EPDF>
+vec mpdf_internal<EPDF>::samplecond (const vec &cond)
+{
+	condition (cond);
+	vec temp = iepdf.sample();
+	return temp;
+}
+
+template<class EPDF>
+mat mpdf_internal<EPDF>::samplecond_m (const vec &cond, int N)
+{
+	condition (cond);
+	mat temp (dimension(), N);
+	vec smp (dimension());
+	for (int i = 0; i < N; i++) {
+		smp = iepdf.sample();
+		temp.set_col (i, smp);
 	}
-	//! Matrix version of logpred
-	vec logpred_m ( const mat &dt ) const {
-		vec tmp ( dt.cols() );
-		for ( int i = 0; i < dt.cols(); i++ ) {
-			tmp ( i ) = logpred ( dt.get_col ( i ) );
-		}
-		return tmp;
-	}
-
-	//!Constructs a predictive density \f$ f(d_{t+1} |d_{t}, \ldots d_{0}) \f$
-	virtual epdf* epredictor() const {
-		it_error ( "Not implemented" );
-		return NULL;
-	};
-	//!Constructs a conditional density 1-step ahead predictor \f$ f(d_{t+1} |d_{t+h-1}, \ldots d_{t})
-	virtual mpdf* predictor() const {
-		it_error ( "Not implemented" );
-		return NULL;
-	};
-	//!@}
-
-	//! \name Extension to conditional BM
-	//! This extension is useful e.g. in Marginalized Particle Filter (\ref bdm::MPF).
-	//! Alternatively, it can be used for automated connection to DS when the condition is observed
-	//!@{
-
-	//! Name of extension variable
-	RV rvc;
-	//! access function
-	const RV& _rvc() const {
-		return rvc;
-	}
-
-	//! Substitute \c val for \c rvc.
-	virtual void condition ( const vec &val ) {
-		it_error ( "Not implemented!" );
-	};
-
-	//!@}
-
-
-	//! \name Access to attributes
-	//!@{
-
-	const RV& _drv() const {
-		return drv;
-	}
-	void set_drv ( const RV &rv ) {
-		drv = rv;
-	}
-	void set_rv ( const RV &rv ) {
-		const_cast<epdf&> ( posterior() ).set_rv ( rv );
-	}
-	double _ll() const {
-		return ll;
-	}
-	void set_evalll ( bool evl0 ) {
-		evalll = evl0;
-	}
-	virtual const epdf& posterior() const = 0;
-	virtual const epdf* _e() const = 0;
-	//!@}
-
-	//! \name Logging of results
-	//!@{
-
-	//! Set boolean options from a string, recognized are: "logbounds,logll"
-	virtual void set_options ( const string &opt ) {
-		LFlags ( 0 ) = 1;
-		if ( opt.find ( "logbounds" ) != string::npos ) {
-			LFlags ( 1 ) = 1;
-			LFlags ( 2 ) = 1;
-		}
-		if ( opt.find ( "logll" ) != string::npos ) {
-			LFlags ( 3 ) = 1;
-		}
-	}
-	//! IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll]
-	ivec LIDs;
-
-	//! Flags for logging - same size as LIDs, each entry correspond to the same in LIDs
-	ivec LFlags;
-	//! Add all logged variables to a logger
-	virtual void log_add ( logger &L, const string &name = "" ) {
-		// internal
-		RV r;
-		if ( posterior().isnamed() ) {
-			r = posterior()._rv();
-		} else {
-			r = RV ( "est", posterior().dimension() );
-		};
-
-		// Add mean value
-		if ( LFlags ( 0 ) ) LIDs ( 0 ) = L.add ( r, name + "mean_" );
-		if ( LFlags ( 1 ) ) LIDs ( 1 ) = L.add ( r, name + "lb_" );
-		if ( LFlags ( 2 ) ) LIDs ( 2 ) = L.add ( r, name + "ub_" );
-		if ( LFlags ( 3 ) ) LIDs ( 3 ) = L.add ( RV ( "ll", 1 ), name );    //TODO: "local" RV
-	}
-	virtual void logit ( logger &L ) {
-		L.logit ( LIDs ( 0 ), posterior().mean() );
-		if ( LFlags ( 1 ) || LFlags ( 2 ) ) {  //if one of them is off, its LID==-1 and will not be stored
-			vec ub, lb;
-			posterior().qbounds ( lb, ub );
-			L.logit ( LIDs ( 1 ), lb );
-			L.logit ( LIDs ( 2 ), ub );
-		}
-		if ( LFlags ( 3 ) ) L.logit ( LIDs ( 3 ), ll );
-	}
-	//!@}
-};
-
+
+	return temp;
+}
+
+template<class EPDF>
+double mpdf_internal<EPDF>::evallogcond (const vec &dt, const vec &cond)
+{
+	double tmp;
+	condition (cond);
+	tmp = iepdf.evallog (dt);
+	// it_assert_debug(std::isfinite(tmp), "Infinite value");
+	return tmp;
+}
+
+template<class EPDF>
+vec mpdf_internal<EPDF>::evallogcond_m (const mat &Dt, const vec &cond)
+{
+	condition (cond);
+	return iepdf.evallog_m (Dt);
+}
+
+template<class EPDF>
+vec mpdf_internal<EPDF>::evallogcond_m (const Array<vec> &Dt, const vec &cond)
+{
+	condition (cond);
+	return iepdf.evallog_m (Dt);
+}
 
 }; //namespace
Index: library/bdm/base/bdmbase.cpp
===================================================================
--- library/bdm/base/bdmbase.cpp (revision 487)
+++ library/bdm/base/bdmbase.cpp (revision 488)
@@ -140,44 +140,4 @@
 }
 
-template<class EPDF>
-vec mpdf_internal<EPDF>::samplecond ( const vec &cond ) {
-	condition ( cond );
-	vec temp = iepdf.sample();
-	return temp;
-}
-
-template<class EPDF>
-mat mpdf_internal<EPDF>::samplecond_m ( const vec &cond, int N ) {
-	condition ( cond );
-	mat temp ( dimension(), N );
-	vec smp ( dimension() );
-	for ( int i = 0; i < N; i++ ) {
-		smp = iepdf.sample();
-		temp.set_col ( i, smp );
-	}
-
-	return temp;
-}
-
-template<class EPDF>
-double mpdf_internal<EPDF>::evallogcond ( const vec &dt, const vec &cond ) {
-	double tmp;
-	condition ( cond );
-	tmp = iepdf.evallog ( dt );
-	// it_assert_debug(std::isfinite(tmp), "Infinite value");
-	return tmp;
-}
-
-template<class EPDF>
-vec mpdf_internal<EPDF>::evallogcond_m ( const mat &Dt, const vec &cond ) {
-	condition ( cond );
-	return iepdf.evallog_m ( Dt );
-}
-
-template<class EPDF>
-		vec mpdf_internal<EPDF>::evallogcond_m ( const Array<vec> &Dt, const vec &cond ) {
-	condition ( cond );
-	return iepdf.evallog_m ( Dt );
-}
 
 void mpdf::from_setting ( const Setting &set ) {
Index: library/bdm/stat/emix.cpp
===================================================================
--- library/bdm/stat/emix.cpp (revision 477)
+++ library/bdm/stat/emix.cpp (revision 488)
@@ -199,4 +199,19 @@
 	return aprgiw;
 };
+
+vec mmix::samplecond(const vec &cond) {
+	//Sample which component
+	vec cumDist = cumsum ( w );
+	double u0;
+#pragma omp critical
+	u0 = UniRNG.sample();
+
+	int i = 0;
+	while ( ( cumDist ( i ) < u0 ) && ( i < ( w.length() - 1 ) ) ) {
+		i++;
+	}
+
+	return Coms ( i )->samplecond(cond);
+}
 
 }
